#DEFINE WIN32_LEAN_AND_MEAN
#DEFINE LINKFILES
#INCLUDE <windows.h>
#include <commctrl.h>

NUMLINES	equ 20
DATA SECTION


items STRUCT
	iIndex	dd 0
	szLabel	 db 22 dup (?)
	szDesc   db 42 dup (?)
	ENDS
devcaps	items <HORZSIZE,	'HORZSIZE',    "Width in millimeters:" >
     	items <VERTSIZE,	'VERTSIZE',    "Height in millimeters:">
     	items <HORZRES,  	'HORZRES',     "Width in pixels:">
     	items <VERTRES,  	'VERTRES',     "Height in raster lines:">
     	items <BITSPIXEL,   'BITSPIXEL',   "Color bits per pixel:">
     	items <PLANES,      'PLANES',      "Number of color planes:">
     	items <NUMBRUSHES,  'NUMBRUSHES',  "Number of device brushes:">
     	items <NUMPENS,     'NUMPENS',     "Number of device pens:"> 
     	items <NUMMARKERS,  'NUMMARKERS',  "Number of device markers:">
     	items <NUMFONTS,    'NUMFONTS',    "Number of device fonts:">
     	items <NUMCOLORS,   'NUMCOLORS',   "Number of device colors:">
     	items <PDEVICESIZE, 'PDEVICESIZE', "Size of device structure:">
     	items <ASPECTX,     'ASPECTX',     "Relative width of pixel:">
     	items <ASPECTY,     'ASPECTY',     "Relative height of pixel:">
     	items <ASPECTXY,    'ASPECTXY',    "Relative diagonal of pixel:">
     	items <LOGPIXELSX,  'LOGPIXELSX',  "Horizontal dots per inch:">
     	items <LOGPIXELSY,  'LOGPIXELSY',  "Vertical dots per inch:">
     	items <SIZEPALETTE, 'SIZEPALETTE', "Number of palette entries:">
     	items <NUMRESERVED, 'NUMRESERVED', "Reserved palette entries:">
     	items <COLORRES,    'COLORRES',    "Actual color resolution:">



ALIGN 4
   	ClassName			DB "MainWinClass",0
	AppName				DB "DEVCAPS1 GOASM VERSION ",0
	szFMT				db "%5d",0
 	hInstance			DD ?
 	Dtest				db 22 dup (?)
	CommandLine			DD ?
;	hwnd				dd ?
	      cxChar		dd ?
	      cxCaps		dd 0
	      cyChar		dd 0
	    cyChar_i		dd 0
	   cxCaps_14		dd 0 
	   Caps_Char		dd 0
	

CODE SECTION

STARTt:

	invoke GetModuleHandle, NULL
	mov [hInstance],eax
	invoke GetCommandLine
	mov [CommandLine],eax
	invoke InitCommonControls
	invoke WinMain,[hInstance],NULL,[CommandLine],SW_SHOWNORMAL
	invoke ExitProcess,eax

WinMain FRAME hInst,hPrevInst,CmdLine,CmdShow
	LOCAL 	 wc:WNDCLASSEX,\
	 	    msg:MSG,\
	 	    hwnd:d

	mov D[wc.cbSize],SIZEOF WNDCLASSEX
	mov D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov [wc.lpfnWndProc], OFFSET WndProc
	mov D[wc.cbClsExtra],NULL
	mov D[wc.cbWndExtra],NULL
	push [hInstance]
	pop [wc.hInstance]
	mov D[wc.hbrBackground],COLOR_WINDOW+1
	mov D[wc.lpszMenuName],NULL
	mov [wc.lpszClassName],OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov [wc.hIcon],eax
	mov [wc.hIconSm],eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov [wc.hCursor],eax
	
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
			WS_OVERLAPPEDWINDOW ,CW_USEDEFAULT,\
			CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
			[hInst],NULL

	mov [hwnd],eax

	invoke ShowWindow, [hwnd],[CmdShow]
	invoke UpdateWindow, [hwnd]

	.messloop
		invoke GetMessage, ADDR msg,0,0,0
		or eax,eax
		JZ >.quit
			invoke TranslateMessage, ADDR msg
			invoke DispatchMessage, ADDR msg
	JMP .messloop
	.quit

	mov eax,[msg.wParam]
	ret
ENDF
;
WndProc FRAME hWnd, uMsg, wParam, lParam
uses esi,edi,ebx,edx
  
LOCAL         hdc:d,\ 
;		   cxChar:d,\
;	       cxCaps:d,\
;	       cyChar:d,\	
;	     cyChar_i:d,\		
;	    cxCaps_14:d,\		 
;	    Caps_Char:d,\		
	           ps:PAINTSTRUCT,\
    szBuffer [10]:d,\
     		   tm:TEXTMETRIC
     	   ;saveMe:d	   


	mov eax,[uMsg]
	cmp eax,WM_CREATE
	jne >.WMCOMMAND
		invoke	GetDC,[hWnd]
		mov	d[hdc],eax

// GetTextMetrics (hdc, &tm) ;
// cxChar = tm.tmAveCharWidth ;
// cxCaps = (tm.tmPitchAndFamily & 1 ? 3 : 2) * cxChar / 2 ;
// cyChar = tm.tmHeight + tm.tmExternalLeading 

		;int 3
	    invoke  GetTextMetrics,[hdc],ADDR tm
        mov	ebx,[tm.tmAveCharWidth]					; ebx = cxChar
        mov	[cxChar],ebx 
        mov	al,[tm.tmPitchAndFamily]				;  BYTE  tmPitchAndFamily;
        ;int 3
        and eax,1
        jz >.FALSE_RESULT
        	mov	eax,3
        	jmp > .END_RESULT
        	
.FALSE_RESULT
			mov	eax,3

.END_RESULT 
			shr	ebx,1								; remember cxCaps still in ebx
			xor	edx,edx
			mul	ebx
			mov	[cxCaps],eax
			
			mov	eax,[tm.tmHeight]
			add	eax,[tm.tmExternalLeading]
			mov	[cyChar],eax
				   
			
        invoke  ReleaseDC,[hWnd],[hdc]
		jmp >>.EXIT

	.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >.WMCLOSE
		jmp >>.EXIT

	.WMCLOSE
	cmp eax,WM_CLOSE
	jne >.WMPAINT
		invoke DestroyWindow,[hWnd]
		jmp >>.EXIT
	.WMPAINT
	
	cmp	eax,WM_PAINT
		jne	>>.WMDESTROY
		invoke	BeginPaint,[hWnd],ADDR ps
		mov	[hdc],eax
		mov	esi,0

;for (i = 0 ; i < NUMLINES ; i++)		

		mov edi,addr devcaps

4_LOOP:	
;	
;         
; TextOut (hdc, 0, cyChar * i,devcaps[i].szLabel,lstrlen (devcaps[i].szLabel)) ;
               

		mov	eax,esi				; esi as i counter
		mov	edx,0
		mov	ecx,[cyChar]
		mul	ecx 				;cyChar * i
		mov	[cyChar_i],eax		; save it 
		
		lea edx,[edi+items.szLabel]
		invoke lstrlen, edx
		lea edx,[edi+items.szLabel]
		invoke	TextOut,[hdc],0,[cyChar_i],edx,eax	
	
;--------------------------------------------------------------------		
;TextOut (hdc, 14 * cxCaps, cyChar * i,devcaps[i].szDesc,lstrlen (devcaps[i].szDesc)) 
                        
                        
		mov	eax,[cxCaps]
		mov	edx,0
		mov	ecx,14
		mul ecx						; cxCaps * 14
		mov	[cxCaps_14],eax			; save it for later use	

		
		lea edx,[edi+items.szDesc]  ; load adres first item into edx
		invoke	lstrlen,edx			; check lenght ( its a string )
		lea edx,[edi+items.szDesc]  ; 
		invoke	TextOut,[hdc],[cxCaps_14],[cyChar_i],edx,eax
        
// ----------------------------------------------------------------------
// SetTextAlign (hdc, TA_RIGHT | TA_TOP) ;
// TextOut (hdc, 14 * cxCaps + 35 * cxChar, cyChar * i, szBuffer,wsprintf (szBuffer, TEXT ("%5d"),\
// GetDeviceCaps (hdc, devcaps[i].iIndex))) ;
// SetTextAlign (hdc, TA_LEFT | TA_TOP) ;

 		invoke	SetTextAlign,[hdc],TA_RIGHT |TA_TOP
 		mov	eax,[cxChar]
 		mov	ecx,35
 		xor	edx,edx
 		mul	ecx					; 35 * cxChar
 		add	eax,[cxCaps_14] 	; 14 * cxCaps + 35 * cxChar
 		mov	[Caps_Char],eax		; total back into eax    
 		
 		invoke	GetDeviceCaps,[hdc],[edi+items.iIndex]
		invoke	wsprintf,ADDR szBuffer, ADDR szFMT,eax
		add esp,12
		invoke	TextOut,[hdc],[Caps_Char],[cyChar_i],ADDR szBuffer,eax			
		
		invoke SetTextAlign,[hdc],TA_LEFT | TA_TOP	
		inc	esi										; increment COUNTER
		cmp	esi,NUMLINES 
		je	>.END_LOOP
		;int3
		add edi,sizeof items
		jmp << 4_LOOP
.END_LOOP	
        invoke	EndPaint,[hWnd],ADDR ps
		
		jmp	>.EXIT
	.WMDESTROY
	cmp eax,WM_DESTROY
	jne >.DEFPROC
		invoke PostQuitMessage,NULL
		jmp >>.DEFPROC

	.DEFPROC
		invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]		
		ret

	.EXIT

	xor eax,eax
	ret
ENDF


